var defaults = {};
defaults.epgSearchScrollPoint = 0;
defaults.popularScrollPoint = 0;
defaults.myGuideUpcomingScrollPoint = 0;
defaults.myGuideSeriesScrollPoint = 0;
defaults.recommendedScrollPoint = 0;
defaults.selectedPage = 0;
defaults.channelListSortOrder = [];
defaults.channelListHidden = [];
defaults.nowAndNext = 3;
defaults.twentyFourHourClock = "24";
defaults.currentFilterDay = 0;
defaults.currentFilterTime = -1;
defaults.pageRefreshInterval = 60000;
defaults.updateCheckInterval = 60000;
defaults.maximumPageSize = 700;
defaults.lastUpdateCheck = 0;
defaults.firstAuth = 0;
defaults.shownSubscribeSheet = 0;

var widgetVersion			= "0216028N";
var widgetApplicationName	= "IceTV Remote Widget - Dashboard";
var widgetApiVersion		= "1.2";

var host_url		= "http://www.icetv.com.au/cgi-bin/webremote_api.cgi";
var update_url		= "http://www.icetv.com.au/cgi-bin/downloads.cgi";
var help_url		= 'http://www.icetv.com.au/widgethelp.shtml';
var settings_url	= 'http://www.icetv.com.au/cgi-bin/webmembers.cgi?op=showIceguide';

var api_key		= "470c59ee67c6697351ff4aec29cdbaab";
var api_secret	= "470c5c05cc9ffdfc5cf0597af48e0d58";

var auth_token;
var auth_token_expiry;
var temp_token;
var refreshTimer=0;
var refreshInProgress = false;
var lastPageRefresh = 0;
var prefsShowing = false;
var updateOfferedVersion;
var skipVersion;
var lastUpdateCheck=0;
var updateCheckInterval;
var currentRegion;
var setupComplete = false;
var loggingEnabled = false;

var icetv           = { PILL_RECOMMENDED:                   {}, 
                        PILL_SERIES:                        {}, 
                        PILL_SERIES_CANCEL:                 {}, 
                        PILL_SINGLE:                        {}, 
                        PILL_KEYWORD_REC:                   {}, 
                        PILL_KEYWORD_FAV:                   {}, 
                        PILL_FAVOURITE:                     {},

                        BUTTON_ADD_FAV:                     {}, 
                        BUTTON_DEL_FAV:                     {}, 
                        BUTTON_RECORD_ONCE:                 {}, 
                        BUTTON_RECORD_SERIES:               {}, 
                        BUTTON_UPDATE_SERIES:               {}, 
                        BUTTON_RECORD_KEYWORD:              {}, 
                        BUTTON_UPDATE_KEYWORD:              {}, 
                        BUTTON_DELETE_KEYWORD:              {}, 
                        BUTTON_CREATE_KEYWORD:              {},

                        SHOW_TITLE:                         {}, 
                        SHOW_SUBTITLE:                      {}, 
                        SHOW_TIME:                          {},
                        SHOW_DESCRIPTION:                   {},
                        SHOW_ADDITIONAL:                    {},
                        SHOW_DELETE_BUTTONS:                {},

                        OPTION_LABEL_TYPE:                  {}, 
                        OPTION_DEVICE:                      {}, 
                        OPTION_TYPE:                        {},
                        OPTION_NETWORK:                     {},
                        OPTION_QUALITY:                     {},
                        OPTION_TIME:                        {},
                        OPTION_LIMIT:                       {},
                        OPTION_KEYWORD_PATTERN:             {},
                        OPTION_KEYWORD_FILTER:              {},

                        OPTION_SHEET_SINGLE:                {}, 
                        OPTION_SHEET_SERIES:                {}, 
                        OPTION_SHEET_KEYWORD:               {},

                        SHEET_DELETE_BUTTONS:               {},
                        SHEET_BUTTONS:                      {},
                        SHEET_REC_BUTTONS:                  {},
                        SHEET_REC_DIVIDERS:                 {},
                        EPG_SHEET:                          {},
                        SHEET_CONTAINER:                    {},
                        
                        EPG_CONTAINER:                      {},
                        POPULAR_CONTAINER:                  {},
                        UPCOMING_CONTAINER:                 {},
                        SERIES_CONTAINER:                   {},
                        RECOMMENDED_CONTAINER:              {},

                        STATE_HIDDEN:                       {}, 
                        STATE_VISIBLE:                      {}, 
                        STATE_DISABLED:                     {},
                         
                        FUNCTION_REMOVE_EPISODE:            {},
                        FUNCTION_REMOVE_SERIES:             {},
                        FUNCTION_REMOVE_KEYWORD:            {},
                        FUNCTION_REMOVE_SHOW:               {},

                        FUNCTION_REMOVE_KEYWORD_EPISODE:    {},

                        FUNCTION_RECORD_EPISODE:            {},
                        FUNCTION_RECORD_SHOW:               {},
                        
                        BUTTON_SINGLE_RECORD:               {},
                        BUTTON_SINGLE_CANCEL:               {}, 

                        BUTTON_SERIES_RECORD:               {},
                        BUTTON_SERIES_UPDATE:               {},
                        BUTTON_SERIES_CANCEL:               {},
                        
                        SINGLE_RECORD_SHOWTITLE:            {},
                        SERIES_RECORD_SHOWTITLE:            {},
                        KEYWORD_RECORD_SHOWTITLE:           {},
                        SINGLE_RECORD_LABEL_TYPE:           {},
                        SERIES_RECORD_LABEL_TYPE:           {},
                        KEYWORD_RECORD_LABEL_TYPE:          {},

                        BUTTON_KEYWORD_RECORD:              {},
                        BUTTON_KEYWORD_UPDATE:              {},
                        BUTTON_KEYWORD_CANCEL:              {},
                        
                        IWT_COMMENT:                        {}};


function maximumPageSize(){
	var maxPageSize = loadPref("maximumPageSize");
	if(maxPageSize < 100)
		maxPageSize = 100;
	if(maxPageSize > 3000)
		maxPageSize = 3000;
	return maxPageSize;
}

function loadPref(key){
	if(!widget.preferenceForKey(key)){
		return defaults[key];
	}
	
	return widget.preferenceForKey(key);
}

function savePref(value, key){
	widget.setPreferenceForKey(value, key);
}

var widgetInitialized = false;
var needsCriticalUpdate = false;
var updateWindowVisible = false;
var sheetVisible = false;
var sheetHeight = 0;
var downloadingFeeds = false;
var updatingRemoteFeed = false;
var epgContentStale = false;
var upcomingContentStale = false;

var frontHeight = 0;
var backHeight = 510;

var currentMode = loadPref("selectedPage");

var popularHeight = 196;
var myGuideUpcomingHeight = 100;
var myGuideSeriesHeight = 100;
var frontSpinner;

var sheetCurrentShowID = null;
var sheetCurrentSeriesID = null;

function sortCompleteData(a, b) {
	var dateA = new Date();
	dateA.setTime(a.time)
	var dateB = new Date();
	dateB.setTime(b.time)
	return dateA - dateB;
}

function decodeIceTV( item ) {
         if(item == icetv.SHEET_RECOMMENDED                 )   return "SHEET_RECOMMENDED";
    else if(item == icetv.SHEET_SERIES                      )   return "SHEET_SERIES";
    else if(item == icetv.SHEET_SERIES_CANCEL               )   return "SHEET_SERIES_CANCEL";
    else if(item == icetv.SHEET_SINGLE                      )   return "SHEET_SINGLE";
    else if(item == icetv.SHEET_KEYWORD_REC                 )   return "SHEET_KEYWORD_REC";
    else if(item == icetv.SHEET_KEYWORD_FAV                 )   return "SHEET_KEYWORD_FAV";
    else if(item == icetv.SHEET_FAVOURITE                   )   return "SHEET_FAVOURITE";

    else if(item == icetv.BUTTON_ADD_FAV                    )   return "BUTTON_ADD_FAV";
    else if(item == icetv.BUTTON_DEL_FAV                    )   return "BUTTON_DEL_FAV";
    else if(item == icetv.BUTTON_RECORD_ONCE                )   return "BUTTON_RECORD_ONCE";
    else if(item == icetv.BUTTON_RECORD_SERIES              )   return "BUTTON_RECORD_SERIES";
    else if(item == icetv.BUTTON_UPDATE_SERIES              )   return "BUTTON_UPDATE_SERIES";
    else if(item == icetv.BUTTON_RECORD_KEYWORD             )   return "BUTTON_RECORD_KEYWORD";
    else if(item == icetv.BUTTON_UPDATE_KEYWORD             )   return "BUTTON_UPDATE_KEYWORD";
    else if(item == icetv.BUTTON_DELETE_KEYWORD             )   return "BUTTON_DELETE_KEYWORD";
    else if(item == icetv.BUTTON_CREATE_KEYWORD             )   return "BUTTON_CREATE_KEYWORD";

    else if(item == icetv.BUTTON_SINGLE_RECORD              )   return "BUTTON_SINGLE_RECORD";
    else if(item == icetv.BUTTON_SINGLE_CANCEL              )   return "BUTTON_SINGLE_CANCEL";

    else if(item == icetv.BUTTON_SERIES_RECORD              )   return "BUTTON_SERIES_RECORD";
    else if(item == icetv.BUTTON_SERIES_UPDATE              )   return "BUTTON_SERIES_UPDATE";
    else if(item == icetv.BUTTON_SERIES_CANCEL              )   return "BUTTON_SERIES_CANCEL";
                        
    else if(item == icetv.BUTTON_KEYWORD_RECORD             )   return "BUTTON_KEYWORD_RECORD";
    else if(item == icetv.BUTTON_KEYWORD_UPDATE             )   return "BUTTON_KEYWORD_UPDATE";
    else if(item == icetv.BUTTON_KEYWORD_CANCEL             )   return "BUTTON_KEYWORD_CANCEL";

    else if(item == icetv.OPTION_SHEET_SINGLE               )   return "OPTION_SHEET_SINGLE";
    else if(item == icetv.OPTION_SHEET_SERIES               )   return "OPTION_SHEET_SERIES";
    else if(item == icetv.OPTION_SHEET_KEYWORD              )   return "OPTION_SHEET_KEYWORD";

    else if(item == icetv.STATE_HIDDEN                      )   return "STATE_HIDDEN";
    else if(item == icetv.STATE_VISIBLE                     )   return "STATE_VISIBLE";
    else if(item == icetv.STATE_DISABLED                    )   return "STATE_DISABLED";

    else if(item == icetv.OPTION_LABEL_TYPE                 )   return "OPTION_LABEL_TYPE";
    else if(item == icetv.OPTION_DEVICE                     )   return "OPTION_DEVICE";
    else if(item == icetv.OPTION_TYPE                       )   return "OPTION_TYPE";
    else if(item == icetv.OPTION_NETWORK                    )   return "OPTION_NETWORK";
    else if(item == icetv.OPTION_QUALITY                    )   return "OPTION_QUALITY";
    else if(item == icetv.OPTION_TIME                       )   return "OPTION_TIME";
    else if(item == icetv.OPTION_LIMIT                      )   return "OPTION_LIMIT";
    else if(item == icetv.OPTION_KEYWORD_PATTERN            )   return "OPTION_KEYWORD_PATTERN";
    else if(item == icetv.OPTION_KEYWORD_FILTER             )   return "OPTION_KEYWORD_FILTER";

    else if(item == icetv.SHOW_TITLE                        )   return "SHOW_TITLE";
    else if(item == icetv.SHOW_SUBTITLE                     )   return "SHOW_SUBTITLE";
    else if(item == icetv.SHOW_TIME                         )   return "SHOW_TIME";
    else if(item == icetv.SHOW_DESCRIPTION                  )   return "SHOW_DESCRIPTION";
    else if(item == icetv.SHOW_ADDITIONAL                   )   return "SHOW_ADDITIONAL";
    else if(item == icetv.SHOW_DELETE_BUTTONS               )   return "SHOW_DELETE_BUTTONS";
    else if(item == icetv.SHEET_BUTTONS                     )   return "SHEET_BUTTONS";
    else if(item == icetv.SHEET_REC_BUTTONS                 )   return "SHEET_REC_BUTTONS";
    else if(item == icetv.SHEET_REC_DIVIDERS                )   return "SHEET_REC_DIVIDERS";
    else if(item == icetv.SHEET_KEYWORD_BUTTONS             )   return "SHEET_KEYWORD_BUTTONS";

    else if(item == icetv.SHEET_SINGLE_CONTAINER            )   return "SHEET_SINGLE_CONTAINER";
    else if(item == icetv.SHEET_SERIES_CONTAINER            )   return "SHEET_SERIES_CONTAINER";
    else if(item == icetv.SHEET_KEYWORD_CONTAINER           )   return "SHEET_KEYWORD_CONTAINER";
    
    else if(item == icetv.EPG_SHEET                         )   return "EPG_SHEET";
    else if(item == icetv.SHEET_CONTAINER                   )   return "SHEET_CONTAINER";
    
    else if(item == icetv.PILL_RECOMMENDED                  )   return "PILL_RECOMMENDED";
    else if(item == icetv.PILL_SERIES                       )   return "PILL_SERIES";
    else if(item == icetv.PILL_SERIES_CANCEL                )   return "PILL_SERIES_CANCEL";
    else if(item == icetv.PILL_SINGLE                       )   return "PILL_SINGLE";
    else if(item == icetv.PILL_KEYWORD_REC                  )   return "PILL_KEYWORD_REC";
    else if(item == icetv.PILL_KEYWORD_FAV                  )   return "PILL_KEYWORD_FAV";
    else if(item == icetv.PILL_FAVOURITE                    )   return "PILL_FAVOURITE";
    
    else if(item == icetv.FUNCTION_REMOVE_EPISODE           )   return "FUNCTION_REMOVE_EPISODE";
    else if(item == icetv.FUNCTION_REMOVE_SERIES            )   return "FUNCTION_REMOVE_SERIES";
    else if(item == icetv.FUNCTION_REMOVE_KEYWORD           )   return "FUNCTION_REMOVE_KEYWORD";
    else if(item == icetv.FUNCTION_REMOVE_SHOW              )   return "FUNCTION_REMOVE_SHOW";
    else if(item == icetv.FUNCTION_REMOVE_KEYWORD_EPISODE   )   return "FUNCTION_REMOVE_KEYWORD_EPISODE";

    else if(item == icetv.FUNCTION_RECORD_EPISODE           )   return "FUNCTION_RECORD_EPISODE";
    else if(item == icetv.FUNCTION_RECORD_SHOW              )   return "FUNCTION_RECORD_SHOW";

    else if(item == icetv.SINGLE_RECORD_SHOWTITLE           )   return "SINGLE_RECORD_SHOWTITLE";
    else if(item == icetv.SERIES_RECORD_SHOWTITLE           )   return "SERIES_RECORD_SHOWTITLE";
    else if(item == icetv.KEYWORD_RECORD_SHOWTITLE          )   return "KEYWORD_RECORD_SHOWTITLE";
    else if(item == icetv.SINGLE_RECORD_LABEL_TYPE          )   return "SINGLE_RECORD_LABEL_TYPE";
    else if(item == icetv.SERIES_RECORD_LABEL_TYPE          )   return "SERIES_RECORD_LABEL_TYPE";
    else if(item == icetv.KEYWORD_RECORD_LABEL_TYPE         )   return "KEYWORD_RECORD_LABEL_TYPE";

    else if(item == icetv.IWT_COMMENT                       )   return "IWT_COMMENT";

    else                                                        return "UNKNOWN";
}
