function Recommended(){
	this.isSelected = false;
	this.contentHeight = 0;
	this.height = parseInt(loadPref("recommendedScrollPoint"), 10);	

	this.resizeorigin = 0;
	resizestart = 0;
	
	this.contentArray = new Array();
	this.mergedContent = new Array();
	
	this.containers = new Array();

	this.inSearch = false;
	this.searchString = null;
	this.usingRestoredSearch = false;
	this.recentSearches = Array();
	this.recentSearchesMenu = Array();
	
	this.dlHeader = new Object();
	this.recommendationsDisabled = false;
}

Recommended.prototype.clear = function(){
	while(document.getElementById("recommended_content_inner_container").hasChildNodes())
		document.getElementById("recommended_content_inner_container").removeChild(document.getElementById("recommended_content_inner_container").firstChild);
		
	this.contentArray.length = 0;
	this.mergedContent.length = 0;
	this.containers.length = 0;
	this.inSearch = false;
	this.searchString = null;
	this.contentHeight = 0;
	this.isSelected = false;
}

Recommended.prototype.setup = function(){
	var _self = this;
	document.getElementById("recommended_resize_control").onmousedown = function(event){ _self.beginresize(event); }
	document.getElementById("recommended-controls-search").onsearch = function(){ _self.searchPrelim(); };
	document.getElementById("recommended_resize_control").ondblclick = function(event){ _self.resetHeight(); }
}

Recommended.prototype.searchPrelim = function(){
	if(this.searchtimer != null){
		clearInterval(this.searchtimer);
	}
	this.searchtimer = null;

	var _self = this;
	this.searchtimer = setInterval(function(){ _self.doSearch(); }, 600);
}

Recommended.prototype.endSearch = function(){
	if(!this.usingRestoredSearch)
		this.saveSearch();
	recommended_searchfield.data = "";
	if(this.searchtimer)
		this.searchtimer.ticking = false;
	this.searchtimer = null;
	this.inSearch = false;
	this.searchString = null;
	recommended_search_close.visible = false;
	this.resetDisplay();
}

Recommended.prototype.doSearch = function(){
	sht.forceCloseSheets();
	if(this.searchtimer)
		clearInterval(this.searchtimer)
	this.searchtimer = null;
	
	if(document.getElementById("recommended-controls-search").value.length == 0){
		this.inSearch = false;
		this.searchString = null;
		this.resetDisplay();
	} else {
		if(this.inSearch == false)
			this.inSearch = true;
	
		this.searchString = document.getElementById("recommended-controls-search").value;
		this.filterWithString(this.searchString)
	}
}

Recommended.prototype.resetDisplay = function(searchstring){
	var offset = 0;
	var visibledays = 0;
	var visibleshows = 0;
		
	for(x=0;x<this.containers.length;x++){
		this.containers[x].container.style.top = (x * 13) + "px";
		this.containers[x].container.style.display = "block";
	}
	this.contentHeight = (this.containers.length * 13) + 2;
	this.resize();
}

Recommended.prototype.filterWithString = function(searchstring){
	var visibleshows = 0;

    var tokenArray = smartSplit( " ", searchstring, false, "\"", true );
    var tokenArrayLength = tokenArray.length;

	for(x=0;x<this.containers.length;x++){
        var itemInfo = this.containers[x];

		var found=false;
		var bNegative;
		var strToken;
		var nMatchingTokens=0;
		
		for(var i=0;i<tokenArrayLength;i++){
			strToken = tokenArray[i];
			bNegative = (strToken[0] == '-');
			var bMatchFound=false;

			// Starts with a -, strip it, we have flagged it as a -ve term
			if(bNegative)
				strToken = strToken.slice(1);

            // If the token is one of our reserved words and there is nothing after the ':'
            // then remove the ':' so it acts like a normal word. ie treat 'genre:' as 'genre'
            // but once you type 'genre:foo' then do a genre search for 'foo'
            if(strToken.toLowerCase() == "title:" 		||
               strToken.toLowerCase() == "series:" 		||
               strToken.toLowerCase() == "episode:" 	||
               strToken.toLowerCase() == "desc:" 		||
               strToken.toLowerCase() == "genre:" 		||
               strToken.toLowerCase() == "actor:" 		||
               strToken.toLowerCase() == "director:" 	||
               strToken.toLowerCase() == "repeat:" 		||
               strToken.toLowerCase() == "year:" 		||
               strToken.toLowerCase() == "after:" 		||
               strToken.toLowerCase() == "before:") {
                strToken = strToken.slice(0,strToken.length -1);
            }
            
            /**
             * Title
             */
			// title:boys
			if(strToken.toLowerCase().indexOf("title:") == 0) {
				var strTokenEscaped = strToken.slice(6);
                var matchRegex = new RegExp(strTokenEscaped, "gim");
				var bRegexMatched;
				if(itemInfo.showtitle)
					bRegexMatched=matchRegex.test(itemInfo.showtitle);
				
				if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
					bMatchFound = true;
				}
			}

			else if(strToken.toLowerCase().indexOf("series:") == 0) {
				var strTokenEscaped = strToken.slice(7);
                var matchRegex = new RegExp(strTokenEscaped, "gim");
				var bRegexMatched;
				if(itemInfo.showtitle)
					bRegexMatched=matchRegex.test(itemInfo.showtitle);
				
				if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
					bMatchFound = true;
				}
			}
			/**
			 * Token is not restricted could match anything
			 */
			else
			{
				var bTermFound=false;
				var bNegativeFailed=false;

	            /**
	             * Title
	             */
	            if((!found || bNegative) && itemInfo.showtitle){
	                var matchRegex = new RegExp(strToken, "gim");
					var bRegexMatched=matchRegex.test(itemInfo.showtitle);
				
					/**
					 * 'Normal' term, may match this field
					 */
					if(!bNegative) {
						if(bRegexMatched)
							bTermFound = true;
					} 
					
					/**
					 * 'Negative' term. If it matched this field then check no more
					 */
					else {
						if(!bNegativeFailed){
							if(bRegexMatched)
								bNegativeFailed = true;
						}
					}
					if(!bNegative)
						bMatchFound = bTermFound;
					else
						bMatchFound = !bNegativeFailed;
				}
			}
            if(bMatchFound)
                nMatchingTokens++;
		}
                        
		if(nMatchingTokens == tokenArrayLength) {
			itemInfo.container.style.top = (visibleshows * 13) + "px";
			itemInfo.container.style.display = "block";
			visibleshows++;
        } 
        else
			itemInfo.container.style.display = "none";
	}
	
	this.contentHeight = (visibleshows * 13) + 2;
	this.resize();
}


Recommended.prototype.fillData = function(){
	
}

Recommended.prototype.hide = function(){
	document.getElementById("recommended_container").style.display = "none";
}

Recommended.prototype.show = function(){
	if(this.recommendationsDisabled == true){
		document.getElementById("recommendations_disabled").style.display = "block"
		document.getElementById("recommended_empty").style.display = "none"
		document.getElementById("recommended_container").style.display = "none"
	} else if(this.contentArray.length == 0){
		document.getElementById("recommended_empty").style.display = "block"
		document.getElementById("recommendations_disabled").style.display = "none"
	} else {
		document.getElementById("recommended_empty").style.display = "none"
		document.getElementById("recommendations_disabled").style.display = "none"
		document.getElementById("recommended_container").style.display = "block"
	}
}

Recommended.prototype.isEmpty = function(){
	if(this.contentArray.length == 0)
		return true;
	return false;
}

Recommended.prototype.isDisabled = function(){
	if(this.recommendationsDisabled)
		return true;
	return false;
}

Recommended.prototype.sectionHeight = function(){
	if(this.contentArray.length == 0 || this.recommendationsDisabled)
		return 129;
	
	var height = 0;
	if(this.height == 0)
		height = this.contentHeight;
	else
		if(this.contentHeight > this.height)
			height = this.height;
		else
			height = this.contentHeight;
	if(height < 74)
		return 74;
	if(height > screen.availHeight - 50)
		return screen.availHeight - 50
	return height;
}

Recommended.prototype.animationHeight = function(){
	if(this.contentArray.length == 0 || this.recommendationsDisabled)
		return 125;
	
	if(this.height == 0){
		if(this.contentHeight >= 74){
			if(this.contentHeight > screen.availHeight - 50)
				return screen.availHeight - 54
			return this.contentHeight - 4;
		}
		return 70;
	}
	
	if(this.contentHeight > this.height){
		if(this.height >= 74)
			return this.height - 4;
		return 70;
	} else {
		if(this.contentHeight >= 74)
			return this.contentHeight - 4;
		return 70;
	}
}

Recommended.prototype.buildDisplay = function(){
}

Recommended.prototype.updateDisplay = function(){
	if(this.inSearch && this.searchString != null){
		rcm.doSearch();
		return;
	}
	
	this.containers.length = 0;
	
	while(document.getElementById("recommended_content_inner_container").hasChildNodes())
		document.getElementById("recommended_content_inner_container").removeChild(document.getElementById("recommended_content_inner_container").firstChild);
		
	if(initialSetupComplete && this.isSelected){
		if(this.recommendationsDisabled == true){
			document.getElementById("recommendations_disabled").style.display = "block";
			document.getElementById("recommended_empty").style.display = "none";
			document.getElementById("recommended_container").style.display = "none";
			return;
		} else if(this.contentArray.length == 0){
			document.getElementById("recommended_empty").style.display = "block";
			document.getElementById("recommended_container").style.display = "none";
			document.getElementById("recommendations_disabled").style.display = "none";
			return;	
		} else {
			document.getElementById("recommended_container").style.display = "none";
		}
	}
	
	if(!recommended_container.visible){
		if(initialSetupComplete && this.isSelected){
			document.getElementById("recommended_container").style.display= "block";
			document.getElementById("recommended_container").style.opacity = 1;
			document.getElementById("recommended_empty").style.display = "none";
			document.getElementById("recommendations_disabled").style.display = "none";
		} else {
			document.getElementById("recommended_empty").style.display = "none";
			document.getElementById("recommendations_disabled").style.display = "none";
		}
	}
	
	for(x=0;x<this.contentArray.length;x++){
		var seriesRecord = mgs.recordForID(this.contentArray[x]['series_id']);
		var favRecord = fav.recordForID(this.contentArray[x]['series_id']);

		var header = document.createElement("div");
		header.style.position = "absolute";
		header.style.width = "355px";
		header.style.height = "18px";
		header.style.top = (x * 13) + "px";
		header.setAttribute("onclick", "sht.fillEpgSheetDetails('" + this.contentArray[x]["series_id"] +"', 4, false, false);");
		document.getElementById("recommended_content_inner_container").appendChild(header);
		
		var iconSize = 0;

		var statusImage = document.createElement("div");
		statusImage.style.background = "url(images/remoteicons/remote_recommended.png)";
		statusImage.style.position = "absolute";
		statusImage.style.width = "8px";
		statusImage.style.height = "12px";
		statusImage.style.left = (12 + iconSize) + "px";
		statusImage.style.top = "2px";
		header.appendChild(statusImage);
		iconSize += 13;

		if(seriesRecord || favRecord){
			if(seriesRecord){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_recseries.png";
				statusImage.width = 14;
				statusImage.height = 12;
				statusImage.style.position = "absolute";
				header.appendChild(statusImage);
				statusImage.style.left = (12 + iconSize) + "px";
				statusImage.style.top = "2px";
				iconSize += 18
			}
			if(favRecord){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_favourite.png";
				statusImage.width = 14;
				statusImage.height = 12;
				statusImage.style.position = "absolute";
				statusImage.style.left = (12 + iconSize) + "px";
				statusImage.style.top = "2px";
				header.appendChild(statusImage);
				iconSize += 18
			}
		}

		var showname = document.createElement("div");
		showname.style.position = "absolute";
		showname.innerHTML = this.contentArray[x]["series_name"];
		showname.style.font = "bold 10px Lucida Grande"
		showname.style.left = (12 + iconSize) + "px";
		showname.style.width = (340 - iconSize) + "px";
		showname.style.color = "#ffffff";
		header.appendChild(showname);
		
		var item = {container:header, showtitle:this.contentArray[x]["series_name"]};
		this.containers.push(item);
	}
	this.contentHeight = (x * 13) + 2;
}

Recommended.prototype.resize = function(){
	var height = this.sectionHeight();
//    DEBUGLOG("recommended.js[301]: height: " + height);
//    DEBUGLOG("recommended.js[302]: this.contentHeight: " + this.contentHeight);
//    DEBUGLOG("recommended.js[303]: this.isSelected: " + this.isSelected);
    
	document.getElementById("recommended_container").style.height = (height - 3) + "px";
	document.getElementById("recommended_content_inner_container").style.height = this.contentHeight + "px"
	document.getElementById("recommended_content_container").style.height = height + "px";
	document.getElementById("recommended_resize_control").style.top = (height - 16) + "px";
	document.getElementById("recommended_scroller").style.height = (height - 15) + "px";
	
	if(this.isSelected){
//        DEBUGLOG("recommended.js[313]: Resizing Front to :" + (72 + (height - 2) + 35));
		resizeFront(72 + (height - 2) + 35)
		document.getElementById("main_container").style.height = (height - 4) + "px";
		document.getElementById("main_base").style.top = (72 + (height - 4)) + "px";
	}
	recommendedScrollArea.refresh();
	recommendedScroller.refresh();
}

function doresizeRecommended(event){
  	rcm.doresize(event);
}

function endresizeRecommended(event) {
  	rcm.endresize();
}

Recommended.prototype.beginresize = function(event){
	this.resizeorigin = event.y;
	this.resizestart = this.sectionHeight();
	document.addEventListener("mousemove",doresizeRecommended, false);
	document.addEventListener("mouseup", endresizeRecommended, false);
}

Recommended.prototype.doresize = function(event){
	newheight =  event.y - this.resizeorigin;
	this.height = this.resizestart + newheight;
	if(this.height < 74)
		this.height = 74;

	if((this.height) > this.contentHeight)
		this.height = this.contentHeight;

	this.resize();
}

Recommended.prototype.endresize = function(){
	document.removeEventListener("mousemove",doresizeRecommended, false);
	document.removeEventListener("mouseup", endresizeRecommended, false);
	savePref(this.height, "recommendedScrollPoint");
}

Recommended.prototype.resetHeight = function(){
	this.height = 0;
	savePref("0", "recommendedScrollPoint");
	this.isSelected = false;
	oldHeight = parseInt(document.getElementById("recommended_container").style.height, 10);
	this.resize();
	this.isSelected = true;
	resizeFromHeightReset(oldHeight, document.getElementById("recommended_container"));
}

function sortRecommendedSeries(a,b)
{
	var aName = a['series_name'];
	var bName = b['series_name'];
	
	return (aName < bName);
}


Recommended.prototype.downloaderCallback = function(json){
	this.parseData(json);
//	this.updateDisplay();
	seriesRecordDataUpdated();
	keywordRecordDataUpdated();
	
	if(this.inSearch && this.searchString != null){
		rcm.doSearch();
		return;
	}
	
	this.resize();
}

Recommended.prototype.parseData = function(json){
	var currentDate = new Date();
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
	/**
	 * Put response into a temp array in case it fails
	 */
	var tempArray = eval(json);
	if(!tempArray)
		return;
		
	/**
	 * Copy & split temp array into Header & Data
	 */
	this.dlHeader = tempArray.shift();
	this.contentArray.length = 0;
    DEBUGLOG("recommended.js[370]: return_code: " + this.dlHeader["return_code"]);
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
    if(this.dlHeader['return_code'] == "0") {
		this.recommendationsDisabled = false;
    } else if(this.dlHeader['return_code'] == "10") {
        ath.expire();
        return;
    } else if(this.dlHeader['return_code'] == "37") { // Hitting too often
        return;
    } else if(this.dlHeader['return_code'] == "55") {
        ath.subExpired();
        return;
    } else if(this.dlHeader['return_code'] == "59") {
		this.recommendationsDisabled = true;
        return;
    }

	this.contentArray = this.contentArray.concat(tempArray);
	
	/**
	 * Record "last_fetch" to use in limiting "auto hits"
	 */
}

Recommended.prototype.updateData = function(userInitiated){
//	DEBUGLOG("data.js[568]: Recommended.updateData(" + userInitiated + ")");

	var currentDate = new Date();
	var currentEpoch = parseInt(currentDate.getTime() / 1000, 10);
	var lastFetch = this.dlHeader['last_fetch'] ? this.dlHeader['last_fetch'] : 0;
	var timeDifference = currentEpoch - lastFetch;
	var minTimeDifference = (this.dlHeader['min_hit_minutes'] ? this.dlHeader['min_hit_minutes'] : 15) * 60;
	
	if(userInitiated == 'false' && (timeDifference < minTimeDifference))
	{
//		DEBUGLOG("data.js[578]: Auto fetch and last fetch within minimum hit time.");
		return;
	}
	
	rcmDownloader.buildURL(0, userInitiated);
	rmtQueue.setSubActive(kRecommendedFeed);
	rcmDownloader.fetchURL();
}	

Recommended.prototype.recordForID = function(seriesID){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.contentArray[i]['series_id'] == seriesID)
			return this.contentArray[i];
	
	return null;
}